﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Prohlížeč_obrázků
{
    class Výpis_složek
    {
        internal static void nacti_strom(TreeView treeView)
        {
            treeView.Nodes.Add(Directory.GetCurrentDirectory());
            PopulateTreeView(Directory.GetCurrentDirectory(), treeView.Nodes[0]);
            treeView.Nodes[0].Expand();
        }

        private static void PopulateTreeView(string directoryValue, TreeNode parentNode)
        {
            string[] directoryArray =
             Directory.GetDirectories(directoryValue);
            string substringDirectory;
            try
            {
                if (directoryArray.Length != 0)
                {
                    foreach (string directory in directoryArray)
                    {
                        substringDirectory = directory.Substring(
                        directory.LastIndexOf('\\') + 1,
                        directory.Length - directory.LastIndexOf('\\') - 1);

                        TreeNode myNode = new TreeNode(substringDirectory);

                        parentNode.Nodes.Add(myNode);

                        PopulateTreeView(directory, myNode);
                    }
                }
            }
            catch (UnauthorizedAccessException)
            {
                parentNode.Nodes.Add("Access denied");
            }
        }
    }
}
