﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.IO;

namespace Prohlížeč_obrázků
{
    class Zobrazování_obrázků
    {
        internal static zobrazení form_zobrazení;
        private static string img_path;
        private static Image img;
        private static float otocit=0;

        internal static void zobraz_obrázek(string p)
        {
            if (!File.Exists(p)) {
                MessageBox.Show("Obrázek \"" + p + "\" nebyl nalezen.", "Chyba");
                return;
            }

            img_path = p;
            img = Image.FromFile(img_path);

            if(Program.form_procházení!=null)
                 Program.form_procházení.list.Items[p].Selected = true;

            init_form();
        }

        private static void init_form()
        {
            form_zobrazení = new zobrazení();

            form_zobrazení.Text += " - " + Path.GetFileName(img_path);
            form_zobrazení.KeyUp += new KeyEventHandler(form_zobrazení_KeyUp);
            form_zobrazení.info.KeyUp += new KeyEventHandler(form_zobrazení_KeyUp);
            form_zobrazení.Paint += new PaintEventHandler(form_zobrazení_Paint);
            form_zobrazení.Load += new EventHandler(form_zobrazení_Load);

            form_zobrazení.ShowDialog();
        }

        static void form_zobrazení_KeyUp(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.Home:
                    if (Program.form_procházení == null)
                        break;
                    form_zobrazení.Dispose();
                    Zobrazování_obrázků.zobraz_obrázek(Program.form_procházení.list.Items[0].Name);
                    break;
                case Keys.End:
                    if (Program.form_procházení == null)
                        break;
                    form_zobrazení.Dispose();
                    Zobrazování_obrázků.zobraz_obrázek(Program.form_procházení.list.Items[Program.form_procházení.list.Items.Count-1].Name);
                    break;
                case Keys.PageUp:
                    if (Program.form_procházení == null)
                        break;
                    if (Program.form_procházení.list.SelectedItems[0].Index == 0)
                        break;
                    form_zobrazení.Dispose();
                    Zobrazování_obrázků.zobraz_obrázek(Program.form_procházení.list.Items[Program.form_procházení.list.SelectedItems[0].Index - 1].Name);
                    break;
                case Keys.PageDown:
                    if (Program.form_procházení == null)
                        break;
                    if (Program.form_procházení.list.SelectedItems[0].Index == Program.form_procházení.list.Items.Count-1)
                        break;
                    form_zobrazení.Dispose();
                    Zobrazování_obrázků.zobraz_obrázek(Program.form_procházení.list.Items[Program.form_procházení.list.SelectedItems[0].Index + 1].Name);
                    break;
                case Keys.Enter:
                    form_zobrazení.Dispose();
                    break;
                case Keys.Escape:
                    Application.ExitThread();
                    break;
            }
        }

        static void form_zobrazení_Load(object sender, EventArgs e)
        {
            form_zobrazení.info.Items.Add("Jméno: "+Path.GetFileName(img_path));
            FileInfo fl = new FileInfo(img_path);
            form_zobrazení.info.Items.Add("Velikost: "+(fl.Length / 1000).ToString() + "Kb");
            form_zobrazení.info.Items.Add("Datum a čas: " + fl.LastWriteTime.ToString());
            form_zobrazení.info.Items.Add("Rozměry: " + img.Width + "x" + img.Height);
            if (Program.form_procházení != null)
             form_zobrazení.info.Items.Add("Obrázek: " + (Program.form_procházení.list.SelectedItems[0].Index + 1) + " z " + Program.form_procházení.list.Items.Count);
        }

        static void form_zobrazení_Paint(object sender, PaintEventArgs e)
        {   
            e.Graphics.RotateTransform(otocit);
            e.Graphics.DrawImage(img, 120, 0, Screen.PrimaryScreen.Bounds.Width - 200, Screen.PrimaryScreen.Bounds.Height - 200);
            form_zobrazení.Size = new Size(Screen.PrimaryScreen.Bounds.Width - 200 + 126, Screen.PrimaryScreen.Bounds.Height - 200 + 28);
       }
    }
}
